@echo off

set   BCC_EXE="bcc\bcc55\Bin\bcc32"
set SDCC_PATH="SDCC\bin"
set DISAS_EXE="hoja\hoja"

set SDCCWORK=sdccwork\

set TRG=binpaste
copy %TRG%.exe release\tools\
copy %TRG%.txt release\tools\

set TRG=d88tool
copy %TRG%.exe release\tools\
copy %TRG%.txt release\tools\

set TRG=d88todsk1dd
%BCC_EXE% %TRG%.c
copy %TRG%.exe release\tools\
copy %TRG%.c   release\tools\src\
del  %TRG%.obj %TRG%.tds %TRG%.exe

set TRG=bin2p31
%BCC_EXE% %TRG%.c
copy %TRG%.exe release\tools\
copy %TRG%.c   release\tools\src\
del  %TRG%.obj %TRG%.tds %TRG%.exe


rem -------------------------------
rem compile assembler source
rem -------------------------------

set TRG=boot
echo %TRG%.s
copy %TRG%.s %SDCCWORK%
copy %TRG%.s release\P6SOURCE\src\
cd %SDCCWORK%
%SDCC_PATH%\sdasz80 -o -g %TRG%.rel %TRG%.s
cd ..

set TRG=menu
echo %TRG%.s
copy %TRG%.s %SDCCWORK%
copy %TRG%.s release\P6SOURCE\src\
cd %SDCCWORK%
%SDCC_PATH%\sdasz80 -o -g %TRG%.rel %TRG%.s
cd ..

set TRG=ioprog
echo %TRG%.s
copy %TRG%.s %SDCCWORK%
copy %TRG%.s release\P6SOURCE\src\
cd %SDCCWORK%
%SDCC_PATH%\sdasz80 -o -g %TRG%.rel %TRG%.s
cd ..

set TRG=kishu
echo %TRG%.s
copy %TRG%.s %SDCCWORK%
copy %TRG%.s release\P6SOURCE\src\
cd %SDCCWORK%
%SDCC_PATH%\sdasz80 -o -g %TRG%.rel %TRG%.s
cd ..

set TRG=drvprog
echo %TRG%.s
copy %TRG%.s %SDCCWORK%
copy %TRG%.s release\P6SOURCE\src\
cd %SDCCWORK%
%SDCC_PATH%\sdasz80 -o -g %TRG%.rel %TRG%.s
cd ..


rem --------------------------
rem compile C source
rem --------------------------

set TRG=sd6031menu
echo %TRG%
copy %TRG%.c %SDCCWORK%
copy %TRG%.c release\P6SOURCE\src\
copy %TRG%.h %SDCCWORK%
copy %TRG%.h release\P6SOURCE\src\
cd %SDCCWORK%
%SDCC_PATH%\sdcc -mz80 -c --opt-code-speed %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym
cd ..


rem --------------------------
rem link
rem --------------------------

echo link_boot
cd %SDCCWORK%
%SDCC_PATH%\sdcc -mz80 --no-std-crt0 --nostdlib --nostdinc --code-loc 0xf900 --data-loc 0xf9ff boot.rel
cd ..

echo link
cd %SDCCWORK%
%SDCC_PATH%\sdcc -mz80 --no-std-crt0 --nostdlib --nostdinc --code-loc 0xc504 --data-loc 0xd500 menu.rel ioprog.rel kishu.rel drvprog.rel sd6031menu.rel
cd ..

rem ---------------------------
rem convert intel-HEX to binary
rem ---------------------------

set TRG=boot
echo makebin_%TRG%
cd %SDCCWORK%
%SDCC_PATH%\makebin -s 65536 %TRG%.ihx %TRG%.bin
..\binpaste %TRG%.bin -d 0x0000 0xf900
..\binpaste %TRG%.bin -d 0x0100 0xffff
copy %TRG%.bin ..\release\P6SOURCE\
cd ..

set TRG=menu
echo makebin_%TRG%
cd %SDCCWORK%
%SDCC_PATH%\makebin -s 65536 %TRG%.ihx %TRG%.bin
..\binpaste %TRG%.bin -d 0x0000 0xc504
..\binpaste %TRG%.bin -d 0x0ffc 0xffff
copy %TRG%.bin ..\release\P6SOURCE\
cd ..


rem ---------------------------
rem Copy Fat data
rem ---------------------------

set TRG=fat1d
copy %TRG%.bin release\P6SOURCE\

set TRG=fat1dd
copy %TRG%.bin release\P6SOURCE\


rem ---------------------------
rem Disassemble for debug
rem ---------------------------

cd %SDCCWORK%
%DISAS_EXE% -o0f900 -u -h -l0 boot.bin > boot.asm
cd ..

cd %SDCCWORK%
%DISAS_EXE% -o0c504 -u -h -l0 menu.bin > menu.asm
cd ..

