;
; void test(BYTE)
;
	.area	_CODE
_test::
	ld	hl,#2
	add	hl,sp

	ld	a,(hl)
	ld	(0xc200),a

	ret


;
; void p6_reboot(BYTE kishu)
; P6ċN
; kishuF@
;
	.area	_CODE
_p6_reboot::
	ld	hl,#2
	add	hl,sp
	ld	a,(hl)

	bit	2,a
	jr	nz,2$

	bit	0,a
	jr	nz,1$

	; 60
	rst	#0

	; mk2/66
1$:
	ld	a,#0x71
	out	(0xf0),a
	ld	a,#0xdd
	out	(0xf1),a
	rst	#0

	; mk2SR/66SR
2$:
	ld	a,#0xee
	out	(0xc8),a

	ld	a,#0xf8
	out	(0x60),a
	ld	a,#0xfa
	out	(0x61),a
	ld	a,#0xfc
	out	(0x62),a
	ld	a,#0xfe
	out	(0x63),a
	ld	a,#0x08
	out	(0x64),a
	ld	a,#0x0a
	out	(0x65),a
	ld	a,#0x0c
	out	(0x66),a
	ld	a,#0x0e
	out	(0x67),a
	rst	#0

;
; BYTE kishu_det(void)
; RETURNF@Fbit2=mk2SR,66SR / bit1=66,66SR / bit0=mk2,mk2SR,66,66SR
; PC-6001     F0x00
; PC-6001mk2  F0x01
; PC-6601     F0x03
; PC-6001mk2SRF0x05
; PC-6601SR   F0x07
; 
;
	.area	_CODE
_kishu_det::
	di
	ld	l,#0

		;
		; @ƂȊO|[g0xF6gĔ
		;
	ld	c,#0xf6
	in	b,(c)		; |[g0xF6 ̒lۑ
	ld	de,#0x55aa
	out	(c),d		; |[g0xF6 0x55o͂ăeXg
	in	a,(c)
	cp	d		; ǂݏoĊmF
	jr	nz,1$
	out	(c),e		; |[g0xF6 0xAAo͂ăeXg
	in	a,(c)
	cp	e		; ǂݏoĊmF
	jr	nz,1$
	out	(c),b		; |[g0xF6 ̒l߂

	set	0,l

		;
		; mk266Amk2SR66SRfBXNpFIFOgĔ
		;
	ld	a,#0xf3
	out	(0xb1),a	; fBXNɐݒ
	ld	de,#0x55aa
	ld	bc,#0x00d0
	out	(c),d		; fBXNpFIFOAhX0xd0000x55
	ld	bc,#0x80d3
	out	(c),e		; fBXNpFIFOAhX0xd3800xAA

	ld	bc,#0x00d0
	in	a,(c)
	cp	d		; AhX0xd000̒lǂݏoĊmF
	jr	nz,3$

	ld	bc,#0x80d3
	in	a,(c)
	cp	e		; AhX0xd380̒lǂݏoĊmF
	jr	nz,3$

	set	1,l		; PC-6601/PC-6601SR

3$:
		;
		; SR|[g0xA3gĔ
		;
	ld	c,#0xa3
	in	a,(c)		; |[g0xA3ǂݏo
	cpl			; ]i|[gȂȂ0x00)
	ld	d,a
	in	a,(c)		; |[g0xA3ǂݏo
	cpl			; ]i|[gȂȂ0x00)
	ld	e,a
	in	a,(c)		; |[g0xA3ǂݏo
	cpl			; ]i|[gȂȂ0x00)
	ld	b,a
	in	a,(c)		; |[g0xA3ǂݏo
	cpl			; ]i|[gȂȂ0x00)
	or	b
	or	d
	or	e
	jr	z,1$

	set	2,l		; PC-6001mk2SR/PC-6601SR

1$:
	ld	h,#0
	ei
	ret

;
; void delay_sec(BYTE sec)
; Nb҂
; secF҂b
;
	.area	_CODE
_delay_sec::
	ld	hl,#2
	add	hl,sp
	ld	b,(hl)

3$:
	ld	hl,#500
2$:
	ld	a,#0x78
1$:	dec	a
	jr	nz,1$

	dec	hl
	ld	a,h
	or	l
	jr	nz,2$

	djnz	3$

	ret

